﻿@using Syncfusion.Blazor.Popups

<SfDialog @ref="Dialog" Width="@Width" MinHeight="@MinHeight" ShowCloseIcon="@ShowCloseIcon" IsModal="true" Visible="false" CloseOnEscape="@CloseOnEscape">
    <DialogEvents OnClose="@OnClose" OnOpen="@beforeOpen"></DialogEvents>
    <DialogTemplates>
        <Header>
            @{
                if (HeaderTemplate != null)
                {
                    @HeaderTemplate
                }
                else
                {
                    @if (!string.IsNullOrWhiteSpace(this.Breadcrumbs))
                    {
                        <div class="col-12">
                            <span style="font-size:24px;font-weight:bold;">@HeaderText</span>
                        </div>
                        <div class="col-12">
                            <span style="font-size:12px;">@Breadcrumbs</span>
                        </div>
                    }
                    else
                    {
                        @HeaderText
                    }
                }
            }
        </Header>
        <Content>
            @{
                if (ContentTemplate != null)
                    @ContentTemplate
                    else
                        @ContentText
            }
        </Content>
    </DialogTemplates>
    <DialogButtons>
        <DialogButton ButtonModel="@OkBtn" OnClick="@OnAccept" />
        <DialogButton ButtonModel="@CancelBtn" OnClick="@OnCancel" />
    </DialogButtons>
</SfDialog>


@code {

    [Parameter]
    public string Breadcrumbs { get; set; } = "";

    [Parameter]
    public string Width { get; set; } = "300px";

    [Parameter]
    public string MinHeight { get; set; } = "";

    [Parameter]
    public string HeaderText { get; set; }

    [Parameter]
    public string ContentText { get; set; }

    [Parameter]
    public string OkTextButton { get; set; } = "Aceptar";

    [Parameter]
    public string OkButtonCss { get; set; }

    [Parameter]
    public string CancelTextButton { get; set; } = "Cancelar";

    [Parameter]
    public string CancelButtonCss { get; set; }

    [Parameter]
    public RenderFragment ContentTemplate { get; set; }

    [Parameter]
    public RenderFragment HeaderTemplate { get; set; }

    [Parameter]
    public EventCallback OnAccept { get; set; }

    [Parameter]
    public EventCallback OnCancel { get; set; }

    [Parameter]
    public bool ShowCloseIcon { get; set; } = true;

    [Parameter]
    public bool CloseOnEscape { get; set; } = true;

    [Parameter]
    public EventCallback OnClose { get; set; }


    SfDialog Dialog;
    private DialogButtonModel OkBtn = new DialogButtonModel { Content = "Aceptar", IsPrimary = true };
    private DialogButtonModel CancelBtn = new DialogButtonModel { Content = "Cancelar" };
    private bool OkBtnDisabled { get; set; } = false;

    protected override Task OnParametersSetAsync()
    {
        this.CancelBtn.Content = CancelTextButton;
        this.OkBtn.Content = OkTextButton;

        this.CancelBtn.CssClass = this.CancelButtonCss;
        this.OkBtn.CssClass = this.OkButtonCss;

        return base.OnParametersSetAsync();
    }

    public void Show(bool? IsFullScreen = null)
    {
        this.Dialog.Show(IsFullScreen);
    }

    public void Hide(MouseEventArgs Event = null)
    {
        this.Dialog.Hide(Event);
    }

    public async Task DisableAcceptBtn(bool disable = true)
    {
        this.OkBtn.Disabled = disable;
        //this.OkBtnDisabled = disable;
        await Task.Delay(10);
        await this.InvokeAsync(StateHasChanged);
        await Task.Delay(10);
    }

    private void beforeOpen(Syncfusion.Blazor.Popups.BeforeOpenEventArgs args)
    {
        if (!string.IsNullOrWhiteSpace(MinHeight))
        {
            args.MaxHeight = null;
        }
    }
}
